<script lang="ts" setup>
import AppContainer from "@/components/AppContainer.vue";
import PageHeader from "@/components/PageHeader.vue";
import UnitCard from "@/components/UnitCard.vue";
import { unitsGetUnits } from "@/scripts/api-helper";
import { computed } from "vue";
import { useRoute, useRouter } from "vue-router";

import { reactive } from "vue";
import { useQuery } from "vue-query";

const router = useRouter();
const route = useRoute();
const isParentRoute = !route.params.unit_code;

const state = reactive({
  search: "",
  panels: [] as string[],
});

const {
  isLoading,
  isError,
  data: unitsData,
} = useQuery("get-all-units", async () => {
  const res = await unitsGetUnits({});
  if (!res.ok) {
    throw new Error("Failed to get units");
  }
  return res.data;
});

const units = computed(() => {
  if (!unitsData.value) return [];
  const teams = [];
  const commissions = [];
  const coaching = [];
  for (const u of unitsData.value) {
    if (u.code.startsWith("AGEP")) {
      teams.push(u);
    } else if (u.parent_code === "COACHING") {
      coaching.push(u);
    } else {
      commissions.push(u);
    }
  }
  const filteredTeams = teams.filter((u) =>
    (u.code + u.display_name).toLowerCase().includes(state.search.toLowerCase())
  );
  const filteredCommissions = commissions.filter((u) =>
    (u.code + u.display_name).toLowerCase().includes(state.search.toLowerCase())
  );
  const filteredCoaching = coaching.filter((u) =>
    (u.code + u.display_name).toLowerCase().includes(state.search.toLowerCase())
  );
  return {
    teams,
    filteredTeams,
    commissions,
    filteredCommissions,
    coaching,
    filteredCoaching,
  };
});

function searchUpdate() {
  if (state.search === "") {
    state.panels = [];
  } else {
    const p = [];
    if (units.value.filteredTeams.length > 0) p.push("teams");
    if (units.value.filteredCoaching.length > 0) p.push("coaching");
    if (units.value.filteredCommissions.length > 0) p.push("commissions");
    state.panels = p;
    console.log(state.panels);
  }
}
</script>

<template>
  <AppContainer>
    <template v-slot:header>
      <PageHeader
        description="Les unités représente la structure interne de l'association. On y retrouve les différentes équipes et comités qui compose l'AGEPoly. Le principe est fortement inspiré des unités EPFL."
        title="Unités de l'AGEPoly"
      />
    </template>
    <div v-if="isParentRoute">
      <div v-if="isLoading">
        <v-progress-circular
          :size="74"
          :width="11"
          indeterminate
        ></v-progress-circular>
      </div>

      <div v-else-if="isError">
        <h1>Impossible de lister les unités</h1>
      </div>

      <div v-else class="p-3 flex flex-wrap justify-center">
        <div class="w-full mb-3">
          <v-text-field
            v-model="state.search"
            append-inner-icon="mdi-magnify"
            hide-details
            label="Rechercher une unité"
            @update:model-value="searchUpdate"
          ></v-text-field>
        </div>
        <v-expansion-panels v-model="state.panels" multiple>
          <v-expansion-panel title="Comité et équipes" value="teams">
            <v-expansion-panel-text>
              <div
                class="grid grid-cols-1 md:grid-cols-2 lg:grid-cols-3 2xl:grid-cols-4 gap-4"
              >
                <UnitCard
                  v-for="u in units.filteredTeams"
                  v-bind:key="u.unit_code"
                  :icon="null"
                  :subtitle="u.code"
                  :title="u.display_name"
                  @click="router.push(`/units/${u.code}`)"
                />
              </div>
            </v-expansion-panel-text>
          </v-expansion-panel>
          <v-expansion-panel title="Commissions" value="commissions">
            <v-expansion-panel-text>
              <div
                class="grid grid-cols-1 md:grid-cols-2 lg:grid-cols-3 2xl:grid-cols-4 gap-4"
              >
                <UnitCard
                  v-for="u in units.filteredCommissions"
                  v-bind:key="u.unit_code"
                  :icon="null"
                  :subtitle="u.code"
                  :title="u.display_name"
                  @click="router.push(`/units/${u.code}`)"
                />
              </div>
            </v-expansion-panel-text>
          </v-expansion-panel>
          <v-expansion-panel title="Coaching de section" value="coaching">
            <v-expansion-panel-text>
              <div
                class="grid grid-cols-1 md:grid-cols-2 lg:grid-cols-3 2xl:grid-cols-4 gap-4"
              >
                <UnitCard
                  v-for="u in units.filteredCoaching"
                  v-bind:key="u.unit_code"
                  :icon="null"
                  :subtitle="u.code"
                  :title="u.display_name"
                  @click="router.push(`/units/${u.code}`)"
                />
              </div>
            </v-expansion-panel-text>
          </v-expansion-panel>
        </v-expansion-panels>
      </div>
    </div>
    <router-view></router-view>
  </AppContainer>
</template>

<style></style>
